unit searchUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, TrackListView, VTrackTreeView, Mp3TrackData;

type
  TTagEvent = procedure(sender: TObject; tag: TTagObject) of object;

  TSearchForm = class(TForm)
    trackList: TTrackListView;
    edtSearch: TEdit;
    lblTime: TLabel;
    Label2: TLabel;
    btnCancel: TButton;
    btnActivate: TButton;
    cbAll: TCheckBox;
    cbTitle: TCheckBox;
    cbAlbum: TCheckBox;
    cbArtist: TCheckBox;
    lblSize: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    lblCount: TLabel;
    procedure edtSearchKeyPress(Sender: TObject; var Key: Char);
    procedure trackListDurationChange(sender: TObject; str: String);
    procedure trackListTrackDblClick(sender: TObject; str: String);
    procedure btnCancelClick(Sender: TObject);
    procedure btnActivateClick(Sender: TObject);
    procedure edtSearchKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure trackListSizeChange(sender: TObject; size: Int64);
    procedure cbArtistClick(Sender: TObject);
  private
    { Private declarations }
    FStopSearch : boolean;
    procedure OnFound(tag: TTagObject);
    procedure DoSearch;
    function stopsearch:boolean;
  public
    { Public declarations }
    tracktreeview : VTTrackTreeView;
  end;

var
  SearchForm: TSearchForm;

implementation

uses MainUnit, Mp3Names;

{$R *.DFM}

procedure TSearchForm.edtSearchKeyPress(Sender: TObject; var Key: Char);
begin
  if key=chr(13) then
  begin
    DoSearch;
    abort;
  end;
end;

procedure TSearchForm.OnFound(tag: TTagObject);
begin
  trackList.AddTrackTag(tag);
end;


procedure TSearchForm.trackListDurationChange(sender: TObject;
  str: String);
begin
  lblTime.caption := str;
end;

procedure TSearchForm.trackListTrackDblClick(sender: TObject;
  str: String);
begin
  mainform.ActivateList( tracklist);
  mainform.playsong(str);
end;

function TSearchForm.StopSearch:boolean;
begin
  application.processmessages;
  result :=  FStopSearch;
end;

procedure TSearchForm.DoSearch;
begin
  caption := 'searching';
  tracklist.clearList;
  FStopSearch := false;
  btnCancel.enabled := true;
  tracktreeview.Search(edtSearch.text, OnFound, stopsearch,
    cbTitle.checked,cbArtist.checked,cbalbum.checked, cbAll.checked);
  btnCancel.enabled := false;
  caption := 'search ready ' + inttostr(tracklist.count) + ' found';
end;

procedure TSearchForm.btnCancelClick(Sender: TObject);
begin
  FStopSearch := true;
end;

procedure TSearchForm.btnActivateClick(Sender: TObject);
begin
  tracklist.rewind;
  mainform.ActivateList( tracklist);
  mainform.next;
end;

procedure TSearchForm.edtSearchKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = 0 then
    abort;
end;

procedure TSearchForm.trackListSizeChange(sender: TObject; size: Int64);
begin
  lblSize.caption := sizetostr(size);
  lblCount.caption := inttostr(tracklist.count);
end;

procedure TSearchForm.cbArtistClick(Sender: TObject);
begin
  if TCheckBox(sender).checked then cball.checked := false;
end;

end.
