{-----------------------------------------------------------}
{----Purpose : Demo for VT descendants.                     }
{    By      : Ir. G.W. van der Vegt                        }
{    For     :                                              }
{    Module  : Unit1.pas                                    }
{    Depends : 2.5.40 of TVirtualIniTree, TVirtualMemo,     }
{              TVirtualNumberedMemo, TVirtualList           }
{              and TVirtualStringTreeData.                  }
{-----------------------------------------------------------}
{ ddmmyyyy comment                                          }
{ -------- -------------------------------------------------}
{ 14102001-Initial version.                                 }
{-----------------------------------------------------------}
{ nr.    todo                                               }
{ ------ -------------------------------------------------- }
{ 1.     -                                                  }
{                                                           }
{-----------------------------------------------------------}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, VirtualTrees, VirtualIniTree, VirtualStringList, JbiUtils,
  VirtualStringTreeData, IniFiles, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    VirtualIniTree1: TVirtualIniTree;
    VirtualList1: TVirtualList;
    VirtualMemo1: TVirtualMemo;
    VirtualNumberedMemo1: TVirtualNumberedMemo;
    VirtualStringTreeData1: TVirtualStringTreeData;
    Splitter2: TSplitter;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    fWindir : String;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  sections,
  section : TStringList;
  ini     : TIniFile;
  aItem,
  aNode   : TVirtualListViewItem;
  i,j     : Integer;
begin
  VirtualIniTree1.IniFile:=Format('%s\system.ini',[fWinDir]);
  VirtualMemo1.Lines.LoadFromFile(Format('%s\system.ini',[fWinDir]));
  VirtualList1.Lines.LoadFromFile(Format('%s\system.ini',[fWinDir]));
  VirtualNumberedMemo1.Lines.LoadFromFile(Format('%s\system.ini',[fWinDir]));
  Button1.Enabled:=False;
  Button2.Enabled:=True;

  Sections:=TStringList.Create;
  ini:=TIniFile.Create(Format('%s\system.ini',[fWinDir]));
  ini.ReadSections(Sections);
  for i:=0 to Sections.Count-1 do
    begin
      Section:=TStringList.Create;
      aItem:=VirtualStringTreeData1.Data.Add;
      aItem.Caption:='['+Sections[i]+']';
      ini.ReadSection(Sections[i],Section);
      for j:=0 to Section.Count-1 do
        begin
          aNode:=VirtualStringTreeData1.Data.AddChild(aItem,Section[j]);
          aNode.SubItems.Add(ini.ReadString(Sections[i],Section[j],'n/a'));
        end;
      FreeAndNil(Section);
    end;
  ini.Free;
  Sections.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  VirtualIniTree1.IniFile:='';
  VirtualMemo1.Lines.Clear;
  VirtualList1.Lines.Clear;
  VirtualNumberedMemo1.Lines.Clear;
  VirtualStringTreeData1.Data.Clear;
  Button1.Enabled:=True;
  Button2.Enabled:=False;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  p : PChar;
begin
  p:=StrAlloc(MAX_PATH+1);
  GetWindowsDirectory(p,MAX_PATH);
  fWinDir:=p;
  StrDisposeAndNil(p);
end;

end.
