// Include file to determine which compiler is currently being used to build the project/component.
// This file uses ideas from Brad Stowers DFS.inc file (www.delphifreestuff.com).
//----------------------------------------------------------------------------------------------------------------------
// The following symbols are defined:
//
// COMPILER_1  : Kylix/Delphi/C++B 1.x is the compiler.
// COMPILER_1p : Kylix/Delphi/C++B 1.x or higher is the compiler.
// COMPILER_2  : Kylix/Delphi 2.x or C++B 1.x is the compiler.
// COMPILER_2p : Kylix/Delphi 2.0x or higher, or C++B 1.x or higher is the compiler.
// COMPILER_3  : Kylix/Delphi/C++B 3.x is the compiler.
// COMPILER_3p : Kylix/Delphi/C++B 3.x or higher is the compiler.
// COMPILER_4  : Kylix/Delphi/C++B 4.x is the compiler.
// COMPILER_4p : Kylix/Delphi/C++B 4.x or higher is the compiler.
// COMPILER_5  : Kylix/Delphi/C++B 5.x is the compiler.
// COMPILER_5p : Kylix/Delphi/C++B 5.x or higher is the compiler.
// COMPILER_6  : Kylix/Delphi/C++B 6.x is the compiler.
// COMPILER_6p : Kylix/Delphi/C++B 6.x or higher is the compiler.                                       
//
// Only defined if Windows is the target:
// CPPB        : Any version of C++B is being used.
// CPPB_1      : C++B v1.x is being used.
// CPPB_3      : C++B v3.x is being used.
// CPPB_3p     : C++B v3.x or higher is being used.
// CPPB_4      : C++B v4.x is being used.
// CPPB_4p     : C++B v4.x or higher is being used.
// CPPB_5      : C++B v5.x is being used.
// CPPB_5p     : C++B v5.x or higher is being used.
//
// Only defined if Windows is the target:
// DELPHI      : Any version of Delphi is being used.
// DELPHI_1    : Delphi v1.x is being used.
// DELPHI_2    : Delphi v2.x is being used.
// DELPHI_2p   : Delphi v2.x or higher is being used.
// DELPHI_3    : Delphi v3.x is being used.
// DELPHI_3p   : Delphi v3.x or higher is being used.
// DELPHI_4    : Delphi v4.x is being used.
// DELPHI_4p   : Delphi v4.x or higher is being used.
// DELPHI_5    : Delphi v5.x is being used.
// DELPHI_5p   : Delphi v5.x or higher is being used.
// DELPHI_6    : Delphi v6.x is being used.
// DELPHI_6p   : Delphi v6.x or higher is being used.
//
// Only defined if Linux is the target:
// KYLIX       : Any version of Kylix is being used.
// KYLIX_1     : Kylix 1.x is being used.
// KYLIX_1p    : Kylix 1.x or higher is being used.
//----------------------------------------------------------------------------------------------------------------------

{$ifdef Win32}
  {$ifdef VER140}
    {$define COMPILER_6}
    {$define DELPHI}
    {$define DELPHI_6}
  {$endif}

  {$ifdef VER130}
    {$define COMPILER_5}
    {$ifdef BCB}
      {$define CPPB}
      {$define CPPB_5}
    {$else}
      {$define DELPHI}
      {$define DELPHI_5}
    {$endif}
  {$endif}

  {$ifdef VER125}
    {$define COMPILER_4}
    {$define CPPB}
    {$define CPPB_4}
  {$endif}

  {$ifdef VER120}
    {$define COMPILER_4}
    {$define DELPHI}
    {$define DELPHI_4}
  {$endif}

  {$ifdef VER110}
    {$define COMPILER_3}
    {$define CPPB}
    {$define CPPB_3}
  {$endif}

  {$ifdef VER100}
    {$define COMPILER_3}
    {$define DELPHI}
    {$define DELPHI_3}
  {$endif}

  {$ifdef VER93}
    {$define COMPILER_2} // C++B v1 compiler is really v2 
    {$define CPPB}
    {$define CPPB_1}
  {$endif}

  {$ifdef VER90}
    {$define COMPILER_2}
    {$define DELPHI}
    {$define DELPHI_2}
  {$endif}

  {$ifdef VER80}
    {$define COMPILER_1}
    {$define DELPHI}
    {$define DELPHI_1}
  {$endif}

  {$ifdef COMPILER_1}
    {$define COMPILER_1p}
  {$endif}

  {$ifdef COMPILER_2}
    {$define COMPILER_1p}
    {$define COMPILER_2p}
  {$endif}

  {$ifdef COMPILER_3}
    {$define COMPILER_1p}
    {$define COMPILER_2p}
    {$define COMPILER_3p}
  {$endif}

  {$ifdef COMPILER_4}
    {$define COMPILER_1p}
    {$define COMPILER_2p}
    {$define COMPILER_3p}
    {$define COMPILER_4p}
  {$endif}

  {$ifdef COMPILER_5}
    {$define COMPILER_1p}
    {$define COMPILER_2p}
    {$define COMPILER_3p}
    {$define COMPILER_4p}
    {$define COMPILER_5p}
  {$endif}

  {$ifdef COMPILER_6}
    {$define COMPILER_1p}
    {$define COMPILER_2p}
    {$define COMPILER_3p}
    {$define COMPILER_4p}
    {$define COMPILER_5p}
    {$define COMPILER_6p}
  {$endif}

  {$ifdef DELPHI_2}
    {$define DELPHI_2p}
  {$endif}

  {$ifdef DELPHI_3}
    {$define DELPHI_2p}
    {$define DELPHI_3p}
  {$endif}

  {$ifdef DELPHI_4}
    {$define DELPHI_2p}
    {$define DELPHI_3p}
    {$define DELPHI_4p}
  {$endif}

  {$ifdef DELPHI_5}
    {$define DELPHI_2p}
    {$define DELPHI_3p}
    {$define DELPHI_4p}
    {$define DELPHI_5p}
  {$endif}

  {$ifdef DELPHI_6}
    {$define DELPHI_2p}
    {$define DELPHI_3p}
    {$define DELPHI_4p}
    {$define DELPHI_5p}
    {$define DELPHI_6p}
  {$endif}

  {$ifdef CPPB_3}
    {$define CPPB_3p}
  {$endif}

  {$ifdef CPPB_4}
    {$define CPPB_3p}
    {$define CPPB_4p}
  {$endif}

  {$ifdef CPPB_5}
    {$define CPPB_3p}
    {$define CPPB_4p}
    {$define CPPB_5p}
  {$endif}

  {$ifdef CPPB_3+}
    // C++Builder requires this if you use Delphi components in run-time packages.
    {$ObjExportAll On}
  {$endif}

{$else (not Windows)}
  // Linux is the target
  {$define KYLIX_1}
{$endif}

//----------------------------------------------------------------------------------------------------------------------

