unit BpmUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TbpmForm = class(TForm)
    Label1: TLabel;
    btnRst: TButton;
    btnSave: TButton;
    edtBpm: TEdit;
    btnCancel: TButton;
    procedure btnRstClick(Sender: TObject);
    procedure edtBpmKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnSaveClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    timestamps: array[0..10] of TDateTime;
    tstampcnt: integer;
    FBpm: Integer;
    procedure SetBpm(Value: Integer);

  public
    property Bpm: Integer read FBpm write SetBpm;
    { Public declarations }

  end;

var
  bpmForm: TbpmForm;

implementation

{$R *.DFM}

procedure TbpmForm.btnRstClick(Sender: TObject);
begin
  tstampcnt := -1;
  edtBpm.Text := '<' + inttostr(5-tstampcnt) + '>';
  edtBpm.SetFocus;
end;

procedure TbpmForm.edtBpmKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i: integer;
begin
  if key = VK_CONTROL then
  begin
    if tstampcnt < 10 then
    begin
      inc(tstampcnt);
      timestamps[tstampcnt] := now;
    end
    else
    begin
      for i := 1 to 10 do
        timestamps[i - 1] := timestamps[i];
      timestamps[10] := now;
    end;
    edtBpm.Text := '<' + inttostr(5-tstampcnt) + '>';
    if tstampcnt > 4 then
    begin
      fbpm := round((encodetime(0, 1, 0, 0) * tstampcnt) / (timestamps[tstampcnt] - timestamps[0]));
      edtBpm.text := inttostr(fbpm);
    end;
  end
end;

procedure TbpmForm.SetBpm(Value: Integer);
begin
  // TODO -cMM: default body inserted
  edtBpm.text := inttostr(FBpm);
end;

procedure TbpmForm.btnSaveClick(Sender: TObject);
begin
  modalResult := mrok;
end;

procedure TbpmForm.btnCancelClick(Sender: TObject);
begin
  modalResult := MRCANCEL;
end;

procedure TbpmForm.FormShow(Sender: TObject);
begin
  tstampcnt := -1;
  edtBpm.Text := '<' + inttostr(5-tstampcnt) + '>';
  edtBpm.SetFocus;
end;

end.
