unit FieldUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, vtracktreeview, Mp3TrackData;

type
  TcolSelectForm = class(TForm)
    lbAll: TListBox;
    lbChosen: TListBox;
    procedure FormShow(Sender: TObject);
    procedure lbChosenDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbAllDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbChosenDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbChosenKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ClearFields;
    procedure AddField(col : TColumnName);
    function GetFieldCount:integer;
    function GetField(index:integer):TColumnName;
  end;

//var
//  colSelectForm: TcolSelectForm;

implementation

{$R *.DFM}

procedure TcolSelectForm.FormShow(Sender: TObject);
var i : TColumnName;
begin
  lbAll.Clear;
  for i := cnName to cnStyle do
    lbAll.items.AddObject(coltostr(i),TObject(i));
end;

procedure TcolSelectForm.lbChosenDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var i : integer;
  p : TPoint;
begin
  if source = lbAll then
  begin
    p.x:=x;p.y := y;
    i := lbChosen.itematpos(p,false);
    lbChosen.Items.InsertObject(i,lbAll.items[lbAll.itemindex],
      lbAll.items.objects[lbAll.itemindex]);
  end;
end;

procedure TcolSelectForm.lbAllDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if sender = lbAll then
    accept := true;
end;

procedure TcolSelectForm.lbChosenDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var i : integer;
begin
  if source = lbAll then
  begin
    i := integer(lbAll.items.Objects[lbAll.ItemIndex]);
    i := lbChosen.Items.IndexOfObject(TObject(i));
    accept := i < 0;
  end;
end;

procedure TcolSelectForm.ClearFields;
begin
  lbChosen.items.clear;
end;

procedure TcolSelectForm.AddField(col : TColumnName);
begin
  lbChosen.items.addObject(coltostr(col),TObject(col));
end;

function TcolSelectForm.GetFieldCount:integer;
begin
  result :=  lbChosen.items.count;
end;

function TcolSelectForm.GetField(index:integer):TColumnName;
begin
  result := TColumnName(lbChosen.items.objects[index]);
end;

procedure TcolSelectForm.lbChosenKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then
    if lbChosen.ItemIndex >= 0 then
      lbChosen.Items.Delete(lbChosen.ItemIndex);
end;

end.
