unit ShuffleUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, VTrackTreeView;

type
  TShuffleForm = class(TForm)
    rgPlaymode: TRadioGroup;
    GroupBox1: TGroupBox;
    cbGenre: TComboBox;
    chkGenre: TCheckBox;
    cbNotPlayed: TCheckBox;
    cbStyle: TCheckBox;
    cmbStyle: TComboBox;
    procedure rgPlaymodeClick(Sender: TObject);
    procedure cbNotPlayedClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkGenreClick(Sender: TObject);
    procedure cmbStyleChange(Sender: TObject);
  private
    { Private declarations }
    first: boolean;
  public
    { Public declarations }
    vtparent:  VTTrackTreeView;
    genre:     integer;
    style:     string;
    shuffle:   boolean;
    notplayed: boolean;
  end;

var
  ShuffleForm: TShuffleForm;

implementation

{$R *.DFM}
uses mpgtools;

procedure TShuffleForm.rgPlaymodeClick(Sender: TObject);
begin
  vtparent.Playmode := TPlayMode(rgPlaymode.ItemIndex);
end;

procedure TShuffleForm.cbNotPlayedClick(Sender: TObject);
begin
  vtparent.NotPlayed := cbNotPlayed.checked;
end;

procedure TShuffleForm.FormShow(Sender: TObject);
var i: integer;
begin
  if first then
  begin
    for i := 0 to maxstyles do
      cbGenre.Items.add(getgenrestr(i));
    cbGenre.ItemIndex    := genre;
    chkGenre.checked     := genre>=0;
    cbNotPlayed.checked  := notplayed;
    if shuffle then
      rgPlaymode.itemindex := 1;

    if assigned(vtParent.styles) then
    begin
      for i := 0 to vtParent.styles.count-1 do
      begin
        cmbStyle.items.add(vtParent.styles[i]);
      end;
    end;
    cmbStyle.Text := style;
    cbStyle.Checked := length(style) > 0;
    first := false;
  end;
end;

procedure TShuffleForm.FormCreate(Sender: TObject);
begin
  first := true;
end;

procedure TShuffleForm.chkGenreClick(Sender: TObject);
begin
  if chkGenre.checked then
    vtparent.GenreFilter := cbGenre.ItemIndex
  else
    vtparent.GenreFilter := -1;
end;

procedure TShuffleForm.cmbStyleChange(Sender: TObject);
begin
  if cbStyle.Checked then
    vtParent.StyleFilter := cmbStyle.text;
end;

end.

