unit OptionUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, BrowseDr;

type
  TOptionForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    lbDirs: TListBox;
    btnAdd: TButton;
    btnApply: TButton;
    TabSheet2: TTabSheet;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    browse: TdfsBrowseDirectoryDlg;
    procedure btnAddClick(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnApplyClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    procedure saveSettingsReg;
    procedure loadSettingsReg;
    procedure copysettings;
  public
    { Public declarations }
    dirs : TStringList;
  end;

var
  OptionForm: TOptionForm;

implementation

uses registry, MainUnit;
{$R *.DFM}

procedure TOptionForm.btnAddClick(Sender: TObject);
begin
  if Browse.execute then
  begin
    lbdirs.Items.add(browse.Selection);
    btnApply.enabled := true;
  end;
end;

procedure TOptionForm.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_DELETE then
  begin
    lbdirs.Items.Delete(lbDirs.itemindex);
    btnApply.enabled := true;
  end;
end;

procedure TOptionForm.saveSettingsReg;
var
  reg: TRegistry;
  str: string;
  i: integer;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\Mp3tool', True)
      then
    begin
      str := inttostr(lbdirs.items.count);
      for i := 0 to lbDirs.items.count - 1 do
        str := str + ',' + lbDirs.items[i];
      str := str + ',';
      Reg.WriteString('Dirs', str);
    end;
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
end;

procedure TOptionForm.loadSettingsReg;
var
  reg: TRegistry;
  str, val: string;
  i, k, l: integer;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if Reg.OpenKey('\Software\Mp3tool', False)
      then
    begin
      str := Reg.ReadString('Dirs');
      // read the columns
      i := pos(',', str);
      if i > 0 then
      begin
        k := strtoint(copy(str, 1, i - 1));
        str := copy(str, i + 1, length(str));
        i := pos(',', str);
        l := 0;
        while (l < k) do
        begin
          lbDirs.items.add(copy(str, 1, i - 1));
          str := copy(str, i + 1, 1000);
          i := pos(',', str);
          inc(l);
        end;
      end;
    end;
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
  copysettings;
end;

procedure TOptionForm.btnApplyClick(Sender: TObject);
begin
  saveSettingsReg;
  copysettings;
  btnApply.enabled := false;
end;

procedure TOptionForm.FormCreate(Sender: TObject);
begin
  dirs := TStringList.Create;
  loadsettingsreg;
end;

procedure TOptionForm.FormDestroy(Sender: TObject);
begin
  dirs.free;
end;

procedure TOptionForm.copysettings;
var i : integer;
begin
  dirs.clear;
  for i := 0 to lbDirs.items.count-1 do
    dirs.add(lbDirs.Items[i]);
end;

procedure TOptionForm.Button1Click(Sender: TObject);
begin
  mainform.lib.SaveArtists('artists.txt');
end;

procedure TOptionForm.Button3Click(Sender: TObject);
begin
  mainform.lib.SaveArtistsNoStyle('artistnostyle.txt');
end;

end.

