unit PlayListUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, TrackListView, StdCtrls;

type
  TPlayListForm = class(TForm)
    tl: TTrackListView;
    btnSave: TButton;
    lblTime: TLabel;
    Label2: TLabel;
    OpenDialog: TOpenDialog;
    btnLoad: TButton;
    SaveDialog: TSaveDialog;
    btnActivate: TButton;
    Label1: TLabel;
    lblSize: TLabel;
    procedure tlDurationChange(sender: TObject; str: String);
    procedure tlTrackDblClick(sender: TObject; str: String);
    procedure btnSaveClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    procedure btnActivateClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tlSizeChange(sender: TObject; size: Int64);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PlayListForm: TPlayListForm;

implementation

uses MainUnit;

{$R *.DFM}
function sizetostr(size: int64):string;
var str: string;
begin
  if size > 10240 then
  begin
    size := size shr 10;
    str := 'kb';
    if size > 10240 then
    begin
    size := size shr 10;
    str := 'Mb';
    if size > 10240 then
    begin
    size := size shr 10;
    str := 'Gb';
    end;
    end;
  end;
  result := inttostr(size) + ' ' + str;
end;


procedure TPlayListForm.tlDurationChange(sender: TObject;
  str: String);
begin
  lblTime.caption := str;
end;

procedure TPlayListForm.tlTrackDblClick(sender: TObject;
  str: String);
begin
  mainform.activatelist(tl);
  mainform.playsong(str);
end;

procedure TPlayListForm.btnSaveClick(Sender: TObject);
begin
   if savedialog.execute then
     tl.SaveAs(savedialog.FileName);
   caption := extractfilename(savedialog.filename);
   mainform.NamePlayList(self,caption);
end;

procedure TPlayListForm.btnLoadClick(Sender: TObject);
begin
   if tl.count > 0 then
   case application.MessageBox('Delete current content ?','Load playlist',MB_YESNOCANCEL	) of
   IDYES:
     tl.ClearList;
   IDNO:
        ;
   IDCANCEL:
     abort
   end;
   if opendialog.execute then
     tl.Load(opendialog.FileName);
   caption := extractfilename(opendialog.filename);
   mainform.NamePlayList(self,caption);
end;

procedure TPlayListForm.btnActivateClick(Sender: TObject);
begin
  tl.Rewind;
  mainform.activatelist(tl);
  mainform.next;
end;

procedure TPlayListForm.FormDestroy(Sender: TObject);
begin
  mainform.RemovePlayListForm(self);
end;

procedure TPlayListForm.tlSizeChange(sender: TObject; size: Int64);
begin
  lblSize.caption := sizetostr(size);
end;

end.
