unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, VirtualTrees;

type
  TForm1 = class(TForm)
    VirtualStringTree1: TVirtualStringTree;
    Button1: TButton;
    Button2: TButton;
    procedure VirtualStringTree1SaveNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Stream: TStream);
    procedure VirtualStringTree1LoadNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Stream: TStream);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure VirtualStringTree1GetNodeDataSize(Sender: TBaseVirtualTree;
      var NodeDataSize: Integer);
    procedure VirtualStringTree1InitNode(Sender: TBaseVirtualTree;
      ParentNode, Node: PVirtualNode;
      var InitialStates: TVirtualNodeInitStates);
    procedure VirtualStringTree1FreeNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type
  PNodeData = ^TNodeData;
  TNodeData = record
    Caption : string;
    Level: Integer;
    Note : TmemoryStream;  // For rtf text
  end;

procedure TForm1.VirtualStringTree1SaveNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Stream: TStream);
var
  Data: PNodeData;
  Len: integer;
  P: Pointer;
begin
  Data := VirtualStringTree1.GetNodeData(Node);
  Len := Length(Data.Caption);
  Stream.write(Len, SizeOf(Len)); // Write the string length
  Stream.write(PChar( Data.Caption)^, Len);
  Stream.write(Data.Level, SizeOf(Data.Level));
  Len := Data.Note.Size;
  Stream.write(Len, SizeOf(Data.Note.Size));
  P := Data.Note.Memory;
  Stream.write(P^, Len);
end;

procedure TForm1.VirtualStringTree1LoadNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Stream: TStream);
var
  Data: PNodeData;
  Len: integer;
  P: Pointer;
begin
  Data := VirtualStringTree1.GetNodeData(Node);
  Stream.read(Len, SizeOf(Len));  // Read the string length
  SetLength(Data.Caption, Len);
  Stream.read(PChar( Data.Caption)^, Len);
  Stream.read(Data.Level, SizeOf(Data.Level));
  Stream.read(Len, SizeOf(Len));
  Data.Note := TMemoryStream.Create;
  Data.Note.Size := Len;
  P := Data.Note.Memory;
  Stream.read(P^, Len)
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  OldCursor: TCursor;
begin
  OldCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  try
    VirtualStringTree1.SaveToFile('Junk.dat');
  finally
    Screen.Cursor := OldCursor
  end
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  OldCursor: TCursor;
begin
  OldCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  try
    VirtualStringTree1.LoadFromFile('Junk.dat');
  finally
    Screen.Cursor := OldCursor
  end
end;

procedure TForm1.VirtualStringTree1GetNodeDataSize(
  Sender: TBaseVirtualTree; var NodeDataSize: Integer);
begin
  NodeDataSize := SizeOf(TNodeData)
end;

procedure TForm1.VirtualStringTree1InitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode;
  var InitialStates: TVirtualNodeInitStates);
var
  Data: PNodeData;
begin
  Data := VirtualStringTree1.GetNodeData(Node);
  Initialize(Data^); // VT uses GetMem so the dynamic strings are not initialized
  Data.Note := TMemoryStream.Create;
  Data.Caption := 'Hi';
  Data.Level := 1325;
  Data.Note.LoadFromFile('TestMemoryStream.txt');
end;

procedure TForm1.VirtualStringTree1FreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);
var
  Data: PNodeData;
begin
  Data := VirtualStringTree1.GetNodeData(Node);
  Finalize(Data^); // VT uses GetMem so the dynamic strings are not freed
  Data.Note.Free;
  Data.Note := nil;
end;

end.
