unit test_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, fnglogfile;

type
  TMainForm = class(TForm)
    FileEdit: TEdit;
    Label1: TLabel;
    OpenBtn: TButton;
    LogEdit: TEdit;
    Label2: TLabel;
    LogBtn: TButton;
    Bevel1: TBevel;
    ArchModeGroup: TRadioGroup;
    GroupBox1: TGroupBox;
    TimeCheck: TCheckBox;
    SourceCheck: TCheckBox;
    CtgCheck: TCheckBox;
    SessionCheck: TCheckBox;
    BkDirEdit: TEdit;
    Label3: TLabel;
    Button3: TButton;
    LogFile: TFnugryLogFile;
    procedure OpenBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LogFileOpen(Sender: TObject);
    procedure LogFileClose(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LogFileChange(Sender: TObject);
    procedure LogBtnClick(Sender: TObject);
    procedure TimeCheckClick(Sender: TObject);
    procedure SourceCheckClick(Sender: TObject);
    procedure CtgCheckClick(Sender: TObject);
    procedure SessionCheckClick(Sender: TObject);
    procedure ArchModeGroupClick(Sender: TObject);
  private
    procedure UpdateControls;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.OpenBtnClick(Sender: TObject);
begin
   if LogFile.LogOpen then
      LogFile.Close
   else
      begin
         LogFile.LogFileName := FileEdit.Text;
         LogFile.ArchiveDir := BkDirEdit.Text;
         LogFile.Open;
      end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   LogFile.CLose;
end;

procedure TMainForm.LogFileOpen(Sender: TObject);
begin
   OpenBtn.Caption := 'Close';
   UpdateControls;
end;

procedure TMainForm.LogFileClose(Sender: TObject);
begin
   OpenBtn.Caption := 'Open';
   UpdateControls;
end;

procedure TMainForm.UpdateControls;
begin
   TimeCheck.Checked := logTimestamp in LogFile.Options;
   SourceCheck.Checked := logSource in LogFile.Options;
   CtgCheck.Checked := logCategory in LogFile.Options;
   SessionCheck.Checked := logSession in LogFile.Options;
   case LogFile.ArchiveMode of
     bkNone : ArchModeGroup.ItemIndex := 0;
     bkSize : ArchModeGroup.ItemIndex := 1;
     bkDaily : ArchModeGroup.ItemIndex := 2;
     bkWeekly : ArchModeGroup.ItemIndex := 3;
     bkMonthly : ArchModeGroup.ItemIndex := 4;
   end;
end;   


procedure TMainForm.FormShow(Sender: TObject);
begin
   UpdateControls;
end;

procedure TMainForm.LogFileChange(Sender: TObject);
begin
   UpdateControls;
end;

procedure TMainForm.LogBtnClick(Sender: TObject);
begin
   LogFile.LogMsg('Test App', '*', LogEdit.Text);
end;

procedure TMainForm.TimeCheckClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
      LogFile.Options := LogFile.Options + [logTimestamp]
  else
      LogFile.Options := LogFile.Options - [logTimestamp];
end;

procedure TMainForm.SourceCheckClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
      LogFile.Options := LogFile.Options + [logSource]
  else
      LogFile.Options := LogFile.Options - [logSource];
end;

procedure TMainForm.CtgCheckClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
      LogFile.Options := LogFile.Options + [logCategory]
  else
      LogFile.Options := LogFile.Options - [logCategory];
end;

procedure TMainForm.SessionCheckClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
      LogFile.Options := LogFile.Options + [logSession]
  else
      LogFile.Options := LogFile.Options - [logSession];
end;

procedure TMainForm.ArchModeGroupClick(Sender: TObject);
begin
   case ArchModeGroup.ItemIndex of
   0 : LogFile.ArchiveMode := bkNone;
   1 : LogFile.ArchiveMode := bkSize;
   2 : LogFile.ArchiveMode := bkDaily;
   3 : LogFile.ArchiveMode := bkWeekly;
   4 : LogFile.ArchiveMode := bkMonthly;
   end;
end;

end.
